



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WPF: 本地化(Localization) 实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WPF: 本地化(Localization) 实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 04:40:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文将讨论在WPF中一种较为方便的本地化方法。</p>
<p>由于在项目中要实现本地化，所以我在网上查找相关的解决方案。通过一系列调研，发现实现本地化的方法主要有以下三种：</p>
<ol><li>通过编译项目以设置 x:Uid 并使用 LocBaml 工具实现；</li>
<li>通过 DynamicResource 实现；</li>
<li>通过 Resx 文件实现</li></ol>
<p>其中第一种是<a href="https://msdn.microsoft.com/en-us/library/ms788718(v=vs.110).aspx" rel="external nofollow noreferrer">官方介绍</a>的方法，考虑到实现步骤略为复杂，所以直接忽略；</p>
<p>第二种方式的实现，主要是在程序中添加 Resource Dictionary 类型的文件，并在其中放入本地化资源字符串；在 XAML 代码中，直接使用 {DynamicResource XXXX} 来实现；这种方法比较方便，不过它也有两个缺点：</p>
<ul><li>在 XAML 中，引用 DynamicResource 的属性必须为依赖属性，否则会出错；</li>
<li>在 C# 代码中引用稍微有点麻烦，需要从 Resource Dictionary 中获取并转化为字符串</li></ul>
<p>其中第一点可以说是致命缺点，我曾在项目中添加了一个第三方控件，其 Header 属性并不是依赖属性，所以不能使用这种方式；不是依赖属性，当然，也就更不能使用绑定（Binding）来设置了。</p>
<p>所以，之后尝试了第三种方式&mdash;&mdash;使用 resx 文件，事实上，这是一种比较传统的、且普遍的方式，说它传统，是因为在 WinForm 中就可以这么做；说它普遍，是因为在 ASP.net MVC 中也可以这么做；并且，在 UWP 中的实现方式也与此有点类似。可以说，基本上基于 .NET 的各个平台都是以这种或类似这种方式来实现本地化的。并且，事件证明，这种方式的确是非常合适的，也很好用，在 XAML 代码和 C# 代码中均可以非常方便的使用。</p>
<h2>使用 ResX 文件实现</h2>
<p>它的操作步骤大概如下：</p>
<p>1. 创建一个 WPF 项目；</p>
<p>2. 在主窗口中添加几个需要本地化其内容的控件，如 TextBlock、Button等；</p>
<p>3. 展示此项目的 Properties 文件夹，这里已经有一个默认的 Resources.resx，在其中添加本地化字符串；</p>
<p>4. 将其复制，并粘贴到当前位置，将新文件改名为 Resources.en-US.resx，并修改其中的本地化字符串为对应的语言值；</p>
<p>说明：这里我们添加了对英语语言的本地化，至于支持哪些语言的本地化，可以参考这篇文章 <a href="https://docs.microsoft.com/en-us/windows/uwp/publish/supported-languages" rel="external nofollow noreferrer">Supported languages</a>，关于语言匹配可参考这篇文章 <a href="https://docs.microsoft.com/en-us/windows/uwp/globalizing/manage-language-and-region" rel="external nofollow noreferrer">Manage language and region</a>，尽管这两篇文章是针对 UWP 的，不过原则上，对于 WPF&nbsp;也是适用的；</p>
<p>5. 将上述两个 resx 文件的 Access Modifier 修改为 <strong>Public</strong>，默认值是 Internal；如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/676860/201703/676860-20170323150501299-972189791.png" /></p>
<p>接下来就是如何使用了：</p>
<p>6. 在 Xaml 中添加命名空间引用：</p>
<div>
<pre class="prettyprint linenums">xmlns:loc="clr-namespace:WpfLocalizationTest.Properties"</pre>
</div>
<p>7. 使用 {x:Static} 标记引用资源，如下：</p>
<div>
<pre class="prettyprint linenums">&lt;TextBlock Text="{x:Static loc:Resources.Main_Menu_Home}" /&gt;</pre>
</div>
<p>8. 如果需要在代码中引用，也非常简单：</p>
<div>
<pre class="prettyprint linenums">var homePage = Properties.Resources.Main_Menu_Home;</pre>
</div>
<p>经测试，这种方式也支持 IntelliSense（智能提示），如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/676860/201703/676860-20170323150749611-78206078.png" /></p>
<p>如果你没看到智能提示，可以先编译项目。</p>
<p>此时，有两种方式可以测试本地化效果，第一种方式是在控制面板中改变操作系统的语言，第二种方式是通过代码改变 CurrentUICulture；这里我们使用后者，在 App.xaml.cs 中添加如下代码：</p>
<div>
<pre class="prettyprint linenums">        protected override void OnStartup(StartupEventArgs e)<br />
        {<br />
            base.OnStartup(e);<br />
            Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("en-US");<br />
        }</pre>
</div>
<p>运行后就可以看到测试结果了。</p>
<h2>在大型项目中使用</h2>
<p>上面是在 Demo 中展示如何本地化应用，那么在大型项目中是如何来应用这种方式呢？以下简单介绍一下，可以供参考：</p>
<p>1. 在解决方案中创建一个类库项目（或在已有项目中进行后续操作），此项目的用途主要是作资源用；</p>
<p>2. 在其中创建 Localization 文件夹，在这个文件夹下可以再创建针对各个模块的子文件夹，然后在此创建 resx 文件、添加本地化字符串并复制。文件结构如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/676860/201703/676860-20170323150956627-1727310810.png" /></p>
<p>3. 要在主程序中使用，方式和我们在 Demo 中提到的是一样的。首先在主程序项目中添加对新创建项目的引用，然后在 XAML 中添加命名空间和相关代码：</p>
<div>
<pre class="prettyprint linenums">xmlns:loc2="clr-namespace:App.Resources.Localization.MainModule;assembly=App.Resources"</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;Button Margin="5" Padding="5" Content="{x:Static loc2:Resources.Main_New}" /&gt;<br />
&lt;Button Margin="5" Padding="5" Content="{x:Static loc2:Resources.Main_Open}" /&gt;</pre>
</div>
<h2>更方便的方式</h2>
<p>如果软件中有大量的文本需要本地化，那么在 resx 文件中的资源项将会非常多，这时，要在两个甚至更多资源文件中添加、删除、对比、检查项目时，将会非常困难。有没有更方便的方法呢？这里推荐一个 VS Extension: ResX Manager</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/676860/201703/676860-20170323151402174-94858765.png" /></p>
<p>它可以非常方便地管理当前解决方案中的 Resx 文件以及其中的资源项，安装后，在 VS 中工具菜单中可以打开，界面如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/676860/201703/676860-20170323151343486-1703745888.png" /></p>
<p>需要注意的是，如果要添加新资源项时，必须在左侧仅选择目标资源文件。它的具体用法，不属于本文讨论的范围，如果大家有需要了解，可以搜索相关教程。总之，通过这个插件，可以非常方便地创建、删除、管理本地化文本。</p>
<h2>总结</h2>
<p>所以，通过本文所提出的 Resx 文件本地化方案再加 ResXManager 扩展，你就可以方便地在你的 WPF项目中实现本地化了。如果您有更好的建议或意见，请留言交流。</p>
<p><em>参考文章：</em></p>
<p><a href="https://msdn.microsoft.com/en-us/library/ms788718(v=vs.110).aspx" rel="external nofollow noreferrer"><em>WPF Globalization and Localization Overview</em></a></p>
<p><em><a href="https://msdn.microsoft.com/en-us/library/ms746621%28v=vs.110%29.aspx?f=255&amp;MSPPError=-2147217396" rel="external nofollow noreferrer">How to: Localize an Application</a></em></p>
<p><em><a href="https://docs.microsoft.com/en-us/windows/uwp/publish/supported-languages" rel="external nofollow noreferrer">Supported languages</a></em></p>
<p><em><a href="https://docs.microsoft.com/en-us/windows/uwp/globalizing/manage-language-and-region" rel="external nofollow noreferrer">Manage language and region</a></em></p>
<p><em><a href="https://www.codeproject.com/articles/37339/wpf-localization.aspx" rel="external nofollow noreferrer">WPF Localization</a></em></p>
<p><em><a href="https://www.codeproject.com/kb/wpf/wpfusinglocbaml.aspx" rel="external nofollow noreferrer">Localizing WPF Applications using Locbaml</a></em></p>
<p><a href="http://files.cnblogs.com/files/wpinfo/WpfLocalizationTest.rar" rel="external nofollow noreferrer">源码下载</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2vd5v8.html">How to build windows azure PowerShell Source Code</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3wx0q.html">HTML5 的data-&ast; 自定义属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlgmp19.html">利用WinPcap模拟网络包伪造飞秋闪屏报文</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zkkx59.html">vi编辑器选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7l5x9.html">C内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdey42x9.html">Dragger简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yldk5q.html">Go学习笔记&lpar;一&rpar;&colon;Ubuntu 环境下Go的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6nw48.html">python中的继承原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z7y0e9.html">读《Ext&period;JS&period;4&period;First&period;Look》随笔</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1nxw2q.html">&lpar;转载&rpar; ASP&period;NET&lpar;C&num;&rpar; Web Api 通过文件流下载文件到本地实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7ddl8.html">浅析 &period;Net Core中Json配置的自动更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy60zx9.html">studio--常见设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9604p539.html">Spring Boot &plus; Spring Cloud 实现权限管理系统 后端篇（十四）：项目打包部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx5kx8.html">python的try finally &lpar;还真不简单&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwzrgd8.html">ADO&period;NET系列之事务和调用存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjnp5e9.html">Android&lowbar;view的生命周期</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vlp40q.html">《GPU高性能编程CUDA实战》附录二 散列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnk3jgq.html">DDOS与DDOS追踪的介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vxpx2q.html">6&period;安装pyhook报错is not a supported wheel on this platform</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dd1kj8.html">信息工程学院技能大赛 计算机程序设计&lpar;Java&rpar;大赛试题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mel3z6q.html">Dynamics CRM 2015-Auto Save</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge4lrl8.html">C&plus;&plus;学习的心路历程之心理障碍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1zx7yq.html">i&plus;&plus;&semi;&plus;&plus;i的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyo1ek9.html">【Java深入研究】2、JVM类加载机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv10v7yq.html">POJ 2125 Destroying The Graph 二分图 最小点权覆盖</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg0dm48.html">Java之路&mdash;&mdash;名词解释&lpar;一&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mepejoq.html">CSS 中的相对量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpow3zq.html">漂亮的代码3：flatten 一个数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg047e8.html">使用PHP生成二维码（PHPQRCode）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj0oy38.html">《Django By Example》第七章 中文 翻译 （个人学习，渣翻）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
